
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   6. Apr 2007  10:22  *************

	processor  16F628
	radix  DEC

Carry       EQU   0
Zero_       EQU   2
  EXTERN med_a
  EXTERN med_b
  EXTERN med_c
  EXTERN Temperatur

  ; FILE C:\projekte\picsel\dtemp_2\median.c
			;
			;#include <c:\projekte\picsel\cc5\16F628.h>
			;#include <c:\projekte\picsel\cc5\int16CXX.h>
			;#include <c:\projekte\picsel\cc5\inline.h>
			;#include <c:\projekte\picsel\dtemp_2\dtemp.h>
			;
			;extern int16 med_a;
			;extern int16 med_b;
			;extern int16 med_c;
			;
			;extern int16 Temperatur;
			;
			;
			;void MedianFilter(void)
			;{

PROG    CODE
MedianFilter
	GLOBAL MedianFilter
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;/* Beginn Median-Filter */
			;
			;
			;  if (med_a>med_b)
	MOVF  med_a+1,W
	SUBWF med_b+1,W
	BTFSC 0x03,Zero_
	GOTO  m001
	MOVF  med_a+1,W
	XORWF med_b+1,W
	BTFSC 0x03,Carry
	XORLW .128
	ANDLW .128
	BTFSC 0x03,Zero_
	GOTO  m002
	GOTO  m010
m001	MOVF  med_a,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m010
			;   if (med_a<med_c)
m002	MOVF  med_c+1,W
	SUBWF med_a+1,W
	BTFSC 0x03,Zero_
	GOTO  m003
	MOVF  med_a+1,W
	XORWF med_c+1,W
	BTFSC 0x03,Carry
	XORLW .128
	ANDLW .128
	BTFSC 0x03,Zero_
	GOTO  m004
	GOTO  m005
m003	MOVF  med_c,W
	SUBWF med_a,W
	BTFSC 0x03,Carry
	GOTO  m005
			;    Temperatur = med_a;
m004	MOVF  med_a,W
	MOVWF Temperatur
	MOVF  med_a+1,W
	MOVWF Temperatur+1
			;   else
	GOTO  m009
			;    if (med_b<med_c)
m005	MOVF  med_c+1,W
	SUBWF med_b+1,W
	BTFSC 0x03,Zero_
	GOTO  m006
	MOVF  med_b+1,W
	XORWF med_c+1,W
	BTFSC 0x03,Carry
	XORLW .128
	ANDLW .128
	BTFSC 0x03,Zero_
	GOTO  m007
	GOTO  m008
m006	MOVF  med_c,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m008
			;     Temperatur = med_c;
m007	MOVF  med_c,W
	MOVWF Temperatur
	MOVF  med_c+1,W
	MOVWF Temperatur+1
			;    else
	GOTO  m009
			;     Temperatur = med_b;
m008	MOVF  med_b,W
	MOVWF Temperatur
	MOVF  med_b+1,W
	MOVWF Temperatur+1
			;  else
m009	GOTO  m017
			;   if (med_a>med_c)
m010	MOVF  med_a+1,W
	SUBWF med_c+1,W
	BTFSC 0x03,Zero_
	GOTO  m011
	MOVF  med_a+1,W
	XORWF med_c+1,W
	BTFSC 0x03,Carry
	XORLW .128
	ANDLW .128
	BTFSC 0x03,Zero_
	GOTO  m012
	GOTO  m013
m011	MOVF  med_a,W
	SUBWF med_c,W
	BTFSC 0x03,Carry
	GOTO  m013
			;    Temperatur = med_a;
m012	MOVF  med_a,W
	MOVWF Temperatur
	MOVF  med_a+1,W
	MOVWF Temperatur+1
			;   else
	GOTO  m017
			;    if (med_b<med_c)
m013	MOVF  med_c+1,W
	SUBWF med_b+1,W
	BTFSC 0x03,Zero_
	GOTO  m014
	MOVF  med_b+1,W
	XORWF med_c+1,W
	BTFSC 0x03,Carry
	XORLW .128
	ANDLW .128
	BTFSC 0x03,Zero_
	GOTO  m015
	GOTO  m016
m014	MOVF  med_c,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m016
			;     Temperatur = med_b;
m015	MOVF  med_b,W
	MOVWF Temperatur
	MOVF  med_b+1,W
	MOVWF Temperatur+1
			;    else
	GOTO  m017
			;     Temperatur = med_c;
m016	MOVF  med_c,W
	MOVWF Temperatur
	MOVF  med_c+1,W
	MOVWF Temperatur+1
			;     
			;#pragma updateBank 1 /* OFF, all cores */
			;}
m017	RETURN

	END


; *** KEY INFO ***

; 0x0001  110 word(s)  5 % : MedianFilter

; RAM usage: 8 bytes (0 local), 216 bytes free
; Maximum call level: 0
; Total of 111 code words (5 %)
